#version 330

in vec3 vertPosition;
in vec3 vertNormal;
in vec2 vertTexCoord;
in vec3 vertTangent;
in vec3 vertBitangent;

uniform mat4 cameraMatrix;
uniform mat4 modelMatrix;

uniform mat4 lightVPMatrix;
uniform mat4 shadowMappingBiasMatrix;


out vec3 fragVert;
out vec3 fragNormal;
out vec2 fragTexCoord;
out vec4 shadowMappingCoord;

void main() {
    // Pass some variables to the fragment shader    
	fragVert = vertPosition;
	fragNormal = vertNormal;
	fragTexCoord = vertTexCoord;
	
    // transform vertex into shadow mapping space
    //shadowMappingCoord = shadowMappingBiasMatrix * lightVPMatrix * modelMatrix * vec4(vertPosition,1);
    shadowMappingCoord = lightVPMatrix * modelMatrix * vec4(vertPosition, 1);
    //shadowMappingCoord = lightVPMatrix * shadowMappingBiasMatrix * vec4(vertPosition,1);
        
    // Apply all matrix transformations to vert
    gl_Position = cameraMatrix * modelMatrix * vec4(vertPosition, 1);
    
   
}
