#version 330

uniform vec3 cameraPosition;

uniform sampler2D colorTexture;
uniform sampler2D reflectionTexture;
uniform samplerCube skybox;

in vec3 fragNormal;
in vec3 fragPosition;
in vec2 fragTexCoord;

out vec4 color;

void main()
{    
	// diffuse color
	vec3 diffuseColor = texture2D(colorTexture, fragTexCoord).rgb;
	
	// reflection color
	vec3 I = normalize(fragPosition - cameraPosition);
    vec3 R = reflect(I, normalize(fragNormal));
	
	///////////////////////////////
	// Use this with reflection map
	//float reflectionIntensity = texture2D(reflectionTexture, fragTexCoord).r;
	///////////////////////////////

	// fix reflection intensity
	float reflectionIntensity = 0.8;

	vec3 reflectionColor = texture(skybox, R).rgb;

	//color = vec4(diffuseColor, 1.0);
	//color = vec4(reflectionColor, 1.0);
	color = vec4(mix(diffuseColor, reflectionColor, reflectionIntensity), 1.0);
}
