#version 330

uniform mat4 cameraMatrix;
uniform mat4 modelMatrix;

in vec3 vertPosition;
in vec2 vertTexCoord;
in vec3 vertNormal;

out vec3 fragNormal;
out vec3 fragPosition;
out vec2 fragTexCoord;

void main()
{
    gl_Position = cameraMatrix * modelMatrix * vec4(vertPosition, 1.0);
	fragNormal = mat3(transpose(inverse(modelMatrix))) * vertNormal;
	fragPosition = vec3(modelMatrix * vec4(vertPosition, 1.0f));
	fragTexCoord = vertTexCoord;
}  