#version 330

in vec2 fragTexCoord;

out vec4 color;

uniform sampler2D colorTexture;
uniform sampler2D depthTexture;

uniform mat4 viewProjectionInverseMatrix;
uniform mat4 previousViewProjectionMatrix;

uniform mat4 modelMatrix;
uniform mat4 prevModelMatrix;

void main(){
	int numSamples = 10;


    float zOverW = texture2D(depthTexture, fragTexCoord).r;  
   
	
   
   
   

    vec4 H = vec4(fragTexCoord.x * 2 - 1, (1 - fragTexCoord.y) * 2 - 1,  zOverW, 1);  

    vec4 D = H * viewProjectionInverseMatrix;  
   

    vec4 worldPos = D / D.w; 
    

    vec4 currentPos = H;  



    vec4 previousPos = worldPos * previousViewProjectionMatrix;  
	
  
    previousPos /= previousPos.w;  

    vec3 velocity = ((currentPos - previousPos) / 20.f).xyz;  
	
	vec2 pixelVelocity = velocity.xy*2;
	pixelVelocity /= numSamples;
	
	
	vec4 colorTmp = texture2D(colorTexture, fragTexCoord);
	vec2 currentFragTexCoord = fragTexCoord;

    
    
    for(int i = 1; i < numSamples; ++i)	
    {  
		currentFragTexCoord -= pixelVelocity;
		
        vec4 currentColor = texture2D(colorTexture, currentFragTexCoord);  
        
		colorTmp += currentColor;  
    }  
    color = (colorTmp / numSamples);
}